package com.zx.dataservice.config;

import org.springframework.beans.factory.annotation.Value;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import springfox.documentation.builders.ApiInfoBuilder;
import springfox.documentation.builders.RequestHandlerSelectors;
import springfox.documentation.service.ApiInfo;
import springfox.documentation.service.Contact;
import springfox.documentation.spi.DocumentationType;
import springfox.documentation.spring.web.plugins.Docket;
import springfox.documentation.swagger2.annotations.EnableSwagger2;

import java.time.LocalDate;
import java.util.Date;

@EnableSwagger2
@Configuration
public class SwaggerConfig {


    public static final String SWAGGER_SCAN_BASE_PACKAGE = "com.zx.dataservice.controller";

    public static final String VERSION = "1.0.0";

    //是否开启swagger，正式环境一般是需要关闭的（避免不必要的漏洞暴露！），可根据springboot的多环境配置进行设置
    @Value("${swagger.enable}")
    private boolean enableSwagger;

    ApiInfo apiInfo() {
        return new ApiInfoBuilder().title("Swagger API").description("This is to show api description")
                .license("Apache 2.0").licenseUrl("")
                .termsOfServiceUrl("").version(VERSION).contact(new Contact("", "", "")).build();
    }

    @Bean
    public Docket customImplementation() {
        return new Docket(DocumentationType.SWAGGER_2).select()
                .apis(RequestHandlerSelectors.basePackage(SWAGGER_SCAN_BASE_PACKAGE)).build()
                .enable(enableSwagger)
                .directModelSubstitute(LocalDate.class, java.sql.Date.class)
                .directModelSubstitute(Date.class, Date.class).apiInfo(apiInfo());
    }
}
